# Take the potential beta's
# COmpute possible intra party correlation
# Then inter party correlation when the betas are different

# Distributions given by  combs.mat
# Parameter for the function finding the required normal cor

getmethefcors<-function(combs.mat,precision,numsims,targetcor){
  corr_already_done<-list()
  norm_corr_thiscomb<-list()
  allcors<-c()
  
  # Function testing if vector in a list
  isvectorinlist<-function(myList,wantVec){
    inlist<-sapply(myList, function(x, want) isTRUE(all.equal(x, want)), wantVec)
    which<-0
    if(any(inlist)){
      which<-which(inlist==TRUE)
    }
    which
  }
  
  # Loop to get the required correlations. With this loop: we will never
  # Compute the same correlations twice.
  listindex<-1
  for (nomtype in 1:nrow(combs.mat)){
    correlations_to_add<-c()
    amaj<-combs.mat[nomtype,"amaj"]
    amin<-combs.mat[nomtype,"amin"]
    bmaj<-combs.mat[nomtype,"bmaj"]
    bmin<-combs.mat[nomtype,"bmin"]
    
    # Majority correlation
    lst1<-c(amaj,bmaj,amaj,bmaj)
    names(lst1)<-NULL
    # Have we already found the required correlation?
    alreadydone<-isvectorinlist(corr_already_done,lst1)
    if(alreadydone>0){ #Yes: go get it
      correlations_to_add<-c(correlations_to_add,norm_corr_thiscomb[[alreadydone]])
    }else{
      # No: find the correlation
      normalcor_target<-normal_corr_beta2(amaj,bmaj,amaj,bmaj,targetcor,precision,numsims)
      newlst<-lst1
      # Store the beta parameters, to say that we've already done that
      corr_already_done[[listindex]]<-newlst
      # Store the corresponding normal corr.
      norm_corr_thiscomb[[listindex]]<-normalcor_target
      correlations_to_add<-c(correlations_to_add,normalcor_target)
      listindex<-listindex+1 
    }
    
    # Minority correlation
    lst1<-c(amin,bmin,amin,bmin)
    names(lst1)<-NULL
    alreadydone<-isvectorinlist(corr_already_done,lst1)
    # Have we already found the required correlation?
    if(alreadydone>0){ #Yes: go get it
      correlations_to_add<-c(correlations_to_add,norm_corr_thiscomb[[alreadydone]])
    }else{
      normalcor_target<-normal_corr_beta2(amin,bmin,amin,bmin,targetcor,precision,numsims)
      newlst<-lst1
      corr_already_done[[listindex]]<-newlst
      norm_corr_thiscomb[[listindex]]<-normalcor_target
      correlations_to_add<-c(correlations_to_add,normalcor_target)
      listindex<-listindex+1 
    }
    
    # Interparty corrlation
    lst1<-c(amaj,bmaj,amin,bmin)
    names(lst1)<-NULL
    lst2<-c(amin,bmin,amaj,bmaj)
    names(lst2)<-NULL
    alreadydone1<-isvectorinlist(corr_already_done,lst1)
    alreadydone2<-isvectorinlist(corr_already_done,lst2)
    # Have we already found the required correlation?
    if(alreadydone1>0){#Yes: go get it
      correlations_to_add<-c(correlations_to_add,norm_corr_thiscomb[[alreadydone1]])
    }else if(alreadydone2>0){
      correlations_to_add<-c(correlations_to_add,norm_corr_thiscomb[[alreadydone2]])
    }else{
      normalcor_target<-normal_corr_beta2(amaj,bmaj,amin,bmin,targetcor,precision,numsims)
      newlst<-lst1
      corr_already_done[[listindex]]<-newlst
      norm_corr_thiscomb[[listindex]]<-normalcor_target
      correlations_to_add<-c(correlations_to_add,normalcor_target)
      listindex<-listindex+1 
    }
    allcors<-rbind(allcors,correlations_to_add)
  }
  
  # Output distribution of nominee types with required party correlation fo
  #r given target.
  combs.mat.with.cors<-cbind(combs.mat,allcors)
  rownames(combs.mat.with.cors)<-NULL
  
  combs.mat.with.cors
}