# Generate intensities for all simulations

# Input: distribution parameters, number of nominations with those params
# Number of simulations to run, size of the party
# Output: matrix of intensities: columns: nvotes nominations
# Rows: one senator, one simulation.

# Generate independent beta
int_beta3_f<-function(a,b,nvotes,ns,size_party){
  int_nocorr1<-rbeta(size_party*nvotes*ns,shape1=a,shape2=b)
  int_nocorr11<-matrix(int_nocorr1,nvotes,size_party*ns)
  output<-t(int_nocorr11)
  output
}


# Generate correlated betas -- takes the correlation we found
# compute a matrix as int_beta3_f. same column*row thing.
# Need to extract the matrix for the maj and the minority
int_beta3_f_withcor<-function(alpha,beta,alpha2,beta2,sig,ns,numsen,size_maj){
  draw<-rmvnorm(n=ns,mean=rep(0,nrow(Sig)),sigma=Sig) # matrix of ns rows of 100 columns.
  drawbeta1<-qbeta(pnorm(draw[,1:size_maj]),shape1=alpha,shape2=beta)
  drawbeta1<-matrix(t(drawbeta1),ns*size_maj,1)
  drawbeta2<-qbeta(pnorm(draw[,(size_maj+1):numsen]),shape1=alpha2,shape2=beta2)
  drawbeta2<-matrix(t(drawbeta2),ns*(numsen-size_maj),1)
  list(drawmaj=drawbeta1,drawmin=drawbeta2)
}



## Code below: 500 draws (rows), 2 values (columns) with given correlation
## We want XX draws of 100 values with given correlation
# sigma <- matrix(c(4,2,2,3), ncol=2)